// CWebSearchPlugin.h : header file
//
//	Copyright (c) 1997-2006, Firetongue Software
//
#if !defined(AFX_CWEBSEARCHPLUGIN_H__732606F8_7935_4AA4_AF65_DB62828D7A7E__INCLUDED_)
#define AFX_CWEBSEARCHPLUGIN_H__732606F8_7935_4AA4_AF65_DB62828D7A7E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "pluginapi.h"

/////////////////////////////////////////////////////////////////////////////
// CWebSearchPlugin command target

class CWebSearchPlugin : public CCmdTarget
{
protected:
	IOUIPluginHost *m_pHost;
	void GetCommonArtistTitle(IOSelection *pSelection, CString &strArtist, CString &strTitle,
							CString &strTrackArtist, CString &strTrackTitle, CString &strASIN);
	void GetSelectionStrings(IOSelection *pSelection, UINT uID, CString &strSuffix, CString &strMenuText,
							CString &strASIN);

// Attributes
public:
	CWebSearchPlugin() : m_pHost(NULL), m_bEnginesLoaded(FALSE), m_nGoogle(0) { }
	virtual ~CWebSearchPlugin();

	enum {
		ID_WEB_SEARCH_TITLE = 1,
		ID_WEB_SEARCH_ARTIST = 2,
		ID_WEB_SEARCH_ARTIST_TITLE = 3,
		ID_WEB_SEARCH_TRACK_ARTIST = 4,
		ID_WEB_SEARCH_TRACK_ARTIST_TITLE = 5,
		ID_WEB_SEARCH_CUSTOM = 10,
		ID_GOTO_ASIN = 11,
		ID_WEB_SEARCH_ENGINE_FIRST = 20,
	};

	struct CEngineInfo
	{
		CString m_strName;
		CString m_strURL;
	};

	CArray<CEngineInfo, CEngineInfo&> m_engines;
	BOOL m_bEnginesLoaded;
	int m_nGoogle;
	void InitSearchEngines();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWebSearchPlugin)
	//}}AFX_VIRTUAL

// Implementation
protected:
	//virtual ~CWebSearchPlugin();

	// Generated message map functions
	//{{AFX_MSG(CWebSearchPlugin)
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	DECLARE_INTERFACE_MAP()

	BEGIN_INTERFACE_PART(OUIPlugin, IOUIPlugin)
		virtual HRESULT STDMETHODCALLTYPE Initialize(IOUIPluginHost *pHost);
		virtual HRESULT STDMETHODCALLTYPE GetMenuState(UINT command, O_UICONTEXT context,
											IOSelection *pSelection, DWORD *pMenuState,
											BSTR *pbstrMenuText);
		virtual HRESULT STDMETHODCALLTYPE Execute(UINT command, O_UICONTEXT context,
											IOSelection *pSelection, HWND hParent);
	END_INTERFACE_PART(OUIPlugin)
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CWEBSEARCHPLUGIN_H__732606F8_7935_4AA4_AF65_DB62828D7A7E__INCLUDED_)
